diff --git a/hw/xquartz/console_redirect.c b/hw/xquartz/console_redirect.c
new file mode 100644
index 000000000..8fdce4699
--- /dev/null
+++ b/hw/xquartz/console_redirect.c
@@ -0,0 +1,482 @@
+/*
+ * Copyright (c) 2011-2012 Apple Inc. All rights reserved.
+ *
+ * Permission is hereby granted, free of charge, to any person
+ * obtaining a copy of this software and associated documentation files
+ * (the "Software"), to deal in the Software without restriction,
+ * including without limitation the rights to use, copy, modify, merge,
+ * publish, distribute, sublicense, and/or sell copies of the Software,
+ * and to permit persons to whom the Software is furnished to do so,
+ * subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be
+ * included in all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
+ * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
+ * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
+ * NONINFRINGEMENT.  IN NO EVENT SHALL THE ABOVE LISTED COPYRIGHT
+ * HOLDER(S) BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
+ * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ *
+ * Except as contained in this notice, the name(s) of the above
+ * copyright holders shall not be used in advertising or otherwise to
+ * promote the sale, use or other dealings in this Software without
+ * prior written authorization.
+ */
+
+#ifdef HAVE_DIX_CONFIG_H
+#include <dix-config.h>
+#else
+#define DEBUG_CONSOLE_REDIRECT 1
+#define HAVE_LIBDISPATCH       1
+#endif
+
+#include <assert.h>
+#include <unistd.h>
+#include <stdio.h>
+#include <string.h>
+#include <stdlib.h>
+#include <sys/types.h>
+#include <sys/event.h>
+#include <asl.h>
+#include <errno.h>
+#include <fcntl.h>
+
+#include "console_redirect.h"
+
+#define BUF_SIZE 512
+
+#ifdef HAVE_LIBDISPATCH
+#include <dispatch/dispatch.h>
+
+static dispatch_queue_t redirect_serial_q;
+static dispatch_group_t read_source_group;
+#else
+#include <pthread.h>
+
+static pthread_t redirect_pthread;
+static pthread_mutex_t redirect_fds_lock = PTHREAD_MUTEX_INITIALIZER;
+
+static int kq;
+
+/* Notifications to our reader thread */
+#define ASL_REDIRECT_TERMINATE ((void *)(uintptr_t)1)
+#endif
+
+typedef struct {
+    int level;
+    aslclient asl;
+    aslmsg msg;
+
+    /* Buffered reading */
+    char *buf;
+    char *w;
+
+#ifdef HAVE_LIBDISPATCH
+    dispatch_source_t read_source;
+#endif
+} asl_redirect;
+
+static asl_redirect *redirect_fds = NULL;
+static int n_redirect_fds = 0;
+
+/* Read from the FD until there is no more to read and redirect to ASL.
+ * Preconditions:
+ *      1: pthread_mutex_lock lock is held (pthreads) or called
+ *         from the appropriate serial queue for operating on
+ *         redirect_fds
+ *      2: fd corresponds to a valid entry in redirect_fds
+ *
+ * Return values:
+ *      If the pipe is closed, EOF is returned regardless of how many bytes
+ *      were processed.  If the pipe is still open, the number of read bytes
+ *      is returned.
+ */
+static inline int
+_read_redirect(int fd, int flush)
+{
+    int total_read = 0;
+    int nbytes;
+    asl_redirect *aslr = &redirect_fds[fd];
+
+    while ((nbytes =
+                read(fd, aslr->w,
+                     BUF_SIZE - (aslr->w - aslr->buf) - 1)) > 0) {
+        char *s, *p;
+
+        /* Increment our returned number read */
+        total_read += nbytes;
+
+        /* Increment our write location */
+        aslr->w += nbytes;
+        aslr->w[0] = '\0';
+
+        /* One line at a time */
+        for (p = aslr->buf; p < aslr->w; p = s + 1) {
+            // Find null or \n
+            for (s = p; *s && *s != '\n'; s++) ;
+            if (*s == '\n') {
+                *s = '\0';
+            }
+
+            if (s < aslr->w || aslr->buf == p) {
+                /* Either the first of multiple messages or one message which is larger than our buffer */
+                asl_log(aslr->asl, aslr->msg, aslr->level, "%s", p);
+            }
+            else {
+                /* We reached the end of the buffer, move this chunk to the start. */
+                memmove(aslr->buf, p, BUF_SIZE - (p - aslr->buf));
+                aslr->w = aslr->buf + (s - p);
+                break;
+            }
+        }
+
+        if (p == aslr->w) {
+            /* Start writing at the beginning in the case where we flushed */
+            aslr->w = aslr->buf;
+        }
+    }
+
+    /* Flush if requested or we're at EOF */
+    if (flush || nbytes == 0) {
+        if (aslr->w > aslr->buf) {
+            *aslr->w = '\0';
+            asl_log(aslr->asl, aslr->msg, aslr->level, "%s", aslr->buf);
+        }
+    }
+
+    if (nbytes == 0)
+        return EOF;
+    return total_read;
+}
+
+#ifdef HAVE_LIBDISPATCH
+static void
+read_from_source(void *_source)
+{
+    dispatch_source_t source = (dispatch_source_t)_source;
+    int fd = dispatch_source_get_handle(source);
+    if (_read_redirect(fd, 0) == EOF) {
+        dispatch_source_cancel(source);
+    }
+}
+
+static void
+cancel_source(void *_source)
+{
+    dispatch_source_t source = (dispatch_source_t)_source;
+    int fd = dispatch_source_get_handle(source);
+    asl_redirect *aslr = &redirect_fds[fd];
+
+    /* Flush the buffer */
+    _read_redirect(fd, 1);
+
+    close(fd);
+    free(aslr->buf);
+    memset(aslr, 0, sizeof(*aslr));
+    dispatch_release(source);
+    dispatch_group_leave(read_source_group);
+}
+
+#else /* !HAVE_LIBDISPATCH */
+static void *
+redirect_thread(void *ctx __unused)
+{
+    struct kevent ev;
+    int n;
+
+    while (1) {
+        n = kevent(kq, NULL, 0, &ev, 1, NULL);
+
+        /* Bail on errors */
+        if (n < 0) {
+            asl_log(NULL, NULL, ASL_LEVEL_ERR, "kevent failure: %s",
+                    strerror(errno));
+            break;
+        }
+
+        /* This should not happen */
+        if (n == 0)
+            continue;
+
+        switch (ev.filter) {
+        case EVFILT_READ:
+            pthread_mutex_lock(&redirect_fds_lock);
+            {
+                int fd = ev.ident;
+                int close_fd = 0;
+                asl_redirect *aslr = &redirect_fds[fd];
+
+                if (fd < 0 || fd >= n_redirect_fds || aslr->buf == NULL) {
+                    asl_log(NULL, NULL, ASL_LEVEL_ERR,
+                            "Unexpected file descriptor: %d",
+                            fd);
+                    goto next;
+                }
+
+                if (ev.flags & EV_EOF) {
+                    close_fd = 1;
+                    if (EOF != _read_redirect(fd, 1)) {
+                        asl_log(
+                            NULL, NULL, ASL_LEVEL_ERR,
+                            "kevent reported EOF on %d, but read doesn't concur.",
+                            fd);
+                    }
+                }
+                else {
+                    close_fd = (EOF == _read_redirect(fd, 0));
+                }
+
+                if (close_fd) {
+                    EV_SET(&ev, fd, EVFILT_READ, EV_DELETE, 0, 0, 0);
+                    kevent(kq, &ev, 1, NULL, 0, NULL);
+                    close(fd);
+                    free(aslr->buf);
+                    memset(aslr, 0, sizeof(*aslr));
+                }
+            }
+next:
+            pthread_mutex_unlock(&redirect_fds_lock);
+
+        case EVFILT_TIMER:
+            if (ev.udata == ASL_REDIRECT_TERMINATE)
+                return NULL;
+
+        default:
+            ;
+            ;
+        }
+    }
+
+    return NULL;
+}
+#endif
+
+static void
+redirect_atexit(void)
+{
+    /* stdout is linebuffered, so flush the buffer */
+    if (redirect_fds[STDOUT_FILENO].buf)
+        fflush(stdout);
+
+#ifdef HAVE_LIBDISPATCH
+    {
+        int i;
+
+        /* Cancel all of our dispatch sources, so they flush to ASL */
+        for (i = 0; i < n_redirect_fds; i++)
+            if (redirect_fds[i].read_source)
+                dispatch_source_cancel(redirect_fds[i].read_source);
+
+        /* Wait at least three seconds for our sources to flush to ASL */
+        dispatch_group_wait(read_source_group,
+                            dispatch_time(DISPATCH_TIME_NOW, 3LL *
+                                          NSEC_PER_SEC));
+    }
+#else
+    {
+        struct kevent ev;
+
+        /* Tell our reader thread it is time to pack up and go home */
+        EV_SET(&ev, 0, EVFILT_TIMER, EV_ADD | EV_ONESHOT, 0, 0,
+               ASL_REDIRECT_TERMINATE);
+        kevent(kq, &ev, 1, NULL, 0, NULL);
+
+        pthread_join(redirect_pthread, NULL);
+    }
+#endif
+}
+
+#ifdef HAVE_LIBDISPATCH
+static void
+xq_asl_init(void *ctx __unused)
+#else
+static void
+xq_asl_init(void)
+#endif
+{
+    assert((redirect_fds = calloc(16, sizeof(*redirect_fds))) != NULL);
+    n_redirect_fds = 16;
+
+#ifdef HAVE_LIBDISPATCH
+    redirect_serial_q = dispatch_queue_create("com.apple.asl-redirect", NULL);
+    assert(redirect_serial_q != NULL);
+
+    read_source_group = dispatch_group_create();
+    assert(read_source_group != NULL);
+#else
+    assert((kq = kqueue()) != -1);
+    assert(pthread_create(&redirect_pthread, NULL, redirect_thread,
+                          NULL) == 0);
+#endif
+
+    atexit(redirect_atexit);
+}
+
+#if MAC_OS_X_VERSION_MIN_REQUIRED < 1050
+#define fls(v) xq_fls(v)
+
+static inline int fls(int value) {
+    unsigned int b, v;
+
+    v = *((unsigned int *)&value);
+
+    for(b=0 ; v ; v >>= 1 , b++);
+
+    return b;
+}
+#endif
+
+int
+xq_asl_log_fd(aslclient asl, aslmsg msg, int level, int fd)
+{
+#ifdef HAVE_LIBDISPATCH
+    int err __block = 0;
+    static dispatch_once_t once_control;
+    dispatch_once_f(&once_control, NULL, xq_asl_init);
+#else
+    int err = 0;
+    static pthread_once_t once_control = PTHREAD_ONCE_INIT;
+    assert(pthread_once(&once_control, xq_asl_init) == 0);
+#endif
+
+    if (fd < 0)
+        return EBADF;
+
+#ifdef HAVE_LIBDISPATCH
+#define BLOCK_DONE return
+    dispatch_sync(redirect_serial_q, ^
+#else
+#define BLOCK_DONE goto done
+    assert(pthread_mutex_lock(&redirect_fds_lock) == 0);
+#endif
+                  {
+                      /* Reallocate if we need more space */
+                      if (fd >= n_redirect_fds) {
+                          size_t new_n = 1 << (fls(fd) + 1);
+                          asl_redirect *new_array =
+                              realloc(redirect_fds, new_n *
+                                      sizeof(*redirect_fds));
+                          if (!new_array) {
+                              err = errno;
+                              BLOCK_DONE;
+                          }
+                          redirect_fds = new_array;
+                          memset(redirect_fds + n_redirect_fds, 0, (new_n -
+                                 n_redirect_fds) * sizeof(*redirect_fds));
+                          n_redirect_fds = new_n;
+                      }
+
+                      /* If we're already listening on it, return error. */
+                      if (redirect_fds[fd].buf != NULL) {
+                          err = EBADF;
+                          BLOCK_DONE;
+                      }
+
+                      /* Initialize our buffer */
+                      redirect_fds[fd].buf = (char *)malloc(BUF_SIZE);
+                      if (redirect_fds[fd].buf == NULL) {
+                          err = errno;
+                          BLOCK_DONE;
+                      }
+                      redirect_fds[fd].w = redirect_fds[fd].buf;
+
+                      /* Store our ASL settings */
+                      redirect_fds[fd].level = level;
+                      redirect_fds[fd].asl = asl;
+                      redirect_fds[fd].msg = msg;
+
+                      /* Don't block on reads from this fd */
+                      fcntl(fd, F_SETFL,
+                            O_NONBLOCK);
+
+                      /* Start listening */
+#ifdef HAVE_LIBDISPATCH
+                      {
+                          dispatch_source_t read_source =
+                              dispatch_source_create(
+                                  DISPATCH_SOURCE_TYPE_READ, fd, 0,
+                                  redirect_serial_q);
+                          redirect_fds[fd].read_source = read_source;
+                          dispatch_set_context(read_source, read_source);
+                          dispatch_source_set_event_handler_f(read_source,
+                                                              read_from_source);
+                          dispatch_source_set_cancel_handler_f(read_source,
+                                                               cancel_source);
+                          dispatch_group_enter(read_source_group);
+                          dispatch_resume(read_source);
+                      }
+#else
+                      {
+                          struct kevent ev;
+                          EV_SET(&ev, fd, EVFILT_READ, EV_ADD, 0, 0, 0);
+                          kevent(kq, &ev, 1, NULL, 0, NULL);
+                      }
+#endif
+                  }
+#ifdef HAVE_LIBDISPATCH
+                  );
+#else
+done:
+                  assert(pthread_mutex_unlock(&redirect_fds_lock) == 0);
+#endif
+#undef BLOCK_DONE
+
+    return err;
+}
+
+int
+xq_asl_capture_fd(aslclient asl, aslmsg msg, int level, int fd)
+{
+    int pipepair[2];
+
+    /* Create pipe */
+    if (pipe(pipepair) == -1)
+        return errno;
+
+    /* Close the read fd but not the write fd on exec */
+    if (fcntl(pipepair[0], F_SETFD, FD_CLOEXEC) == -1)
+        return errno;
+
+    /* Replace the existing fd */
+    if (dup2(pipepair[1], fd) == -1) {
+        close(pipepair[0]);
+        close(pipepair[1]);
+        return errno;
+    }
+
+    /* If we capture STDOUT_FILENO, make sure we linebuffer stdout */
+    if (fd == STDOUT_FILENO)
+        setlinebuf(stdout);
+
+    /* Close the duplicate fds since they've been reassigned */
+    close(pipepair[1]);
+
+    /* Hand off the read end of our pipe to xq_asl_log_fd */
+    return xq_asl_log_fd(asl, msg, level, pipepair[0]);
+}
+
+#ifdef DEBUG_CONSOLE_REDIRECT
+int
+main(int argc __unused, char * *argv __unused)
+{
+    xq_asl_capture_fd(NULL, NULL, ASL_LEVEL_NOTICE, STDOUT_FILENO);
+    xq_asl_capture_fd(NULL, NULL, ASL_LEVEL_ERR, STDERR_FILENO);
+
+    fprintf(stderr, "TEST ERR1\n");
+    fprintf(stdout, "TEST OUT1\n");
+    fprintf(stderr, "TEST ERR2\n");
+    fprintf(stdout, "TEST OUT2\n");
+    system("/bin/echo SYST OUT");
+    system("/bin/echo SYST ERR >&2");
+    fprintf(stdout, "TEST OUT3\n");
+    fprintf(stdout, "TEST OUT4\n");
+    fprintf(stderr, "TEST ERR3\n");
+    fprintf(stderr, "TEST ERR4\n");
+
+    exit(0);
+}
+#endif
diff --git a/hw/xquartz/console_redirect.h b/hw/xquartz/console_redirect.h
new file mode 100644
index 000000000..7b80de405
--- /dev/null
+++ b/hw/xquartz/console_redirect.h
@@ -0,0 +1,46 @@
+/* Copyright (c) 2011-2012 Apple Inc.
+ *
+ * Permission is hereby granted, free of charge, to any person
+ * obtaining a copy of this software and associated documentation files
+ * (the "Software"), to deal in the Software without restriction,
+ * including without limitation the rights to use, copy, modify, merge,
+ * publish, distribute, sublicense, and/or sell copies of the Software,
+ * and to permit persons to whom the Software is furnished to do so,
+ * subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be
+ * included in all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
+ * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
+ * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
+ * NONINFRINGEMENT.  IN NO EVENT SHALL THE ABOVE LISTED COPYRIGHT
+ * HOLDER(S) BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
+ * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ *
+ * Except as contained in this notice, the name(s) of the above
+ * copyright holders shall not be used in advertising or otherwise to
+ * promote the sale, use or other dealings in this Software without
+ * prior written authorization.
+ */
+
+#ifndef _XQUARTZ_CONSOLE_REDIRECT_H_
+#define _XQUARTZ_CONSOLE_REDIRECT_H_
+
+#include <asl.h>
+
+/* The given fd is replaced with a pipe.  Anything written to it will will be
+ * logged to ASL.
+ */
+int
+xq_asl_capture_fd(aslclient asl, aslmsg msg, int level, int fd);
+
+/* The given fd is read from and passed along to ASL until all write ends of the
+ * pipe are closed. Once the last writer has closed the pipe, we close our end.
+ */
+int
+xq_asl_log_fd(aslclient asl, aslmsg msg, int level, int fd);
+
+#endif
diff --git a/hw/xquartz/darwin.c b/hw/xquartz/darwin.c
index e34994673..d72da093b 100644
--- a/hw/xquartz/darwin.c
+++ b/hw/xquartz/darwin.c
@@ -41,6 +41,7 @@
 #include "mipointer.h"          // mi software cursor
 #include "micmap.h"             // mi colormap code
 #include "fb.h"                 // fb framebuffer code
+#include "site.h"
 #include "globals.h"
 #include "dix.h"
 #include "xkbsrv.h"
@@ -167,6 +168,21 @@ DarwinPrintBanner(void)
 {
     ErrorF("Xquartz starting:\n");
     ErrorF("X.Org X Server %s\n", XSERVER_VERSION);
+    ErrorF("Build Date: %s\n", BUILD_DATE);
+}
+
+/*
+ * DarwinSaveScreen
+ *  X screensaver support. Not implemented.
+ */
+static Bool
+DarwinSaveScreen(ScreenPtr pScreen, int on)
+{
+    // FIXME
+    if (on == SCREEN_SAVER_FORCER) {}
+    else if (on == SCREEN_SAVER_ON) {}
+    else {}
+    return TRUE;
 }
 
 /*
@@ -255,6 +271,9 @@ DarwinScreenInit(ScreenPtr pScreen, int argc, char **argv)
     ShmRegisterFbFuncs(pScreen);
 #endif
 
+    // this must be initialized (why doesn't X have a default?)
+    pScreen->SaveScreen = DarwinSaveScreen;
+
     // finish mode dependent screen setup including cursor support
     if (!QuartzSetupScreen(pScreen->myNum, pScreen)) {
         return FALSE;
@@ -825,6 +844,20 @@ ddxGiveUp(enum ExitCode error)
     LogClose(error);
 }
 
+/*
+ * AbortDDX --
+ *      DDX - specific abort routine.  Called by AbortServer(). The attempt is
+ *      made to restore all original setting of the displays. Also all devices
+ *      are closed.
+ */
+_X_NORETURN
+void
+AbortDDX(enum ExitCode error)
+{
+    ErrorF("   AbortDDX\n");
+    OsAbort();
+}
+
 #if INPUTTHREAD
 /** This function is called in Xserver/os/inputthread.c when starting
     the input thread. */
diff --git a/hw/xquartz/darwinEvents.c b/hw/xquartz/darwinEvents.c
index 15c1bc5d8..fd87e968b 100644
--- a/hw/xquartz/darwinEvents.c
+++ b/hw/xquartz/darwinEvents.c
@@ -129,9 +129,6 @@ create_thread(void *(*func)(void *), void *arg)
     pthread_attr_init(&attr);
     pthread_attr_setscope(&attr, PTHREAD_SCOPE_SYSTEM);
     pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_DETACHED);
-    if (&pthread_attr_set_qos_class_np) {
-        pthread_attr_set_qos_class_np(&attr, QOS_CLASS_USER_INITIATED, 0);
-    }
     pthread_create(&tid, &attr, func, arg);
     pthread_attr_destroy(&attr);
 
diff --git a/hw/xquartz/mach-startup/bundle-main.c b/hw/xquartz/mach-startup/bundle-main.c
index de82e2280..b40366244 100644
--- a/hw/xquartz/mach-startup/bundle-main.c
+++ b/hw/xquartz/mach-startup/bundle-main.c
@@ -29,6 +29,7 @@
  */
 
 #include <CoreFoundation/CoreFoundation.h>
+#include <AvailabilityMacros.h>
 
 #ifdef HAVE_DIX_CONFIG_H
 #include <dix-config.h>
@@ -43,7 +44,11 @@
 #include <stdbool.h>
 #include <signal.h>
 
+#ifdef HAVE_LIBDISPATCH
 #include <dispatch/dispatch.h>
+#else
+#include <pthread.h>
+#endif
 
 #include <sys/socket.h>
 #include <sys/un.h>
@@ -56,7 +61,7 @@
 #include "mach_startup.h"
 #include "mach_startupServer.h"
 
-#include <asl.h>
+#include "console_redirect.h"
 
 /* From darwinEvents.c ... but don't want to pull in all the server cruft */
 void
@@ -72,17 +77,13 @@ FatalError(const char *f, ...) _X_ATTRIBUTE_PRINTF(1, 2) _X_NORETURN;
 
 extern int noPanoramiXExtension;
 
-#ifdef COMPOSITE
-extern Bool noCompositeExtension;
-#endif
-
 #define DEFAULT_CLIENT X11BINDIR "/xterm"
 #define DEFAULT_STARTX X11BINDIR "/startx -- " X11BINDIR "/Xquartz"
 #define DEFAULT_SHELL  "/bin/sh"
 
-#define _STRINGIZE(s) #s
-#define STRINGIZE(s) _STRINGIZE(s)
-
+#ifndef BUILD_DATE
+#define BUILD_DATE ""
+#endif
 #ifndef XSERVER_VERSION
 #define XSERVER_VERSION "?"
 #endif
@@ -90,11 +91,15 @@ extern Bool noCompositeExtension;
 static char __crashreporter_info_buff__[4096] = { 0 };
 static const char *__crashreporter_info__ __attribute__((__used__)) =
     &__crashreporter_info_buff__[0];
-// This line just tells the linker to never strip this symbol (such as for space optimization)
+#if MAC_OS_X_VERSION_MIN_REQUIRED >= 1050
+// This is actually a toolchain requirement, but I'm not sure the correct check,
+// but it should be fine to just only include it for Leopard and later.  This line
+// just tells the linker to never strip this symbol (such as for space optimization)
 asm (".desc ___crashreporter_info__, 0x10");
+#endif
 
 static const char *__crashreporter_info__base =
-    "X.Org X Server " XSERVER_VERSION;
+    "X.Org X Server " XSERVER_VERSION " Build Date: " BUILD_DATE;
 
 char *bundle_id_prefix = NULL;
 static char *server_bootstrap_name = NULL;
@@ -114,6 +119,23 @@ static char *pref_app_to_run;
 static char *pref_login_shell;
 static char *pref_startx_script;
 
+#ifndef HAVE_LIBDISPATCH
+/*** Pthread Magics ***/
+static pthread_t
+create_thread(void *(*func)(void *), void *arg)
+{
+    pthread_attr_t attr;
+    pthread_t tid;
+
+    pthread_attr_init(&attr);
+    pthread_attr_setscope(&attr, PTHREAD_SCOPE_SYSTEM);
+    pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_DETACHED);
+    pthread_create(&tid, &attr, func, arg);
+    pthread_attr_destroy(&attr);
+
+    return tid;
+}
+#endif
 
 /*** Mach-O IPC Stuffs ***/
 
@@ -221,9 +243,16 @@ typedef struct {
 /* This thread accepts an incoming connection and hands off the file
  * descriptor for the new connection to accept_fd_handoff()
  */
+#ifdef HAVE_LIBDISPATCH
 static void
 socket_handoff(socket_handoff_t *handoff_data)
 {
+#else
+static void *
+socket_handoff_thread(void *arg)
+{
+    socket_handoff_t *handoff_data = (socket_handoff_t *)arg;
+#endif
 
     int launchd_fd = -1;
     int connected_fd;
@@ -258,6 +287,9 @@ socket_handoff(socket_handoff_t *handoff_data)
         launchd_fd);
     DarwinListenOnOpenFD(launchd_fd);
 
+#ifndef HAVE_LIBDISPATCH
+    return NULL;
+#endif
 }
 
 static int
@@ -341,10 +373,14 @@ do_request_fd_handoff_socket(mach_port_t port, string_t filename)
 
     strlcpy(filename, handoff_data->filename, STRING_T_SIZE);
 
+#ifdef HAVE_LIBDISPATCH
     dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT,
                                              0), ^ {
                        socket_handoff(handoff_data);
                    });
+#else
+    create_thread(socket_handoff_thread, handoff_data);
+#endif
 
 #ifdef DEBUG
     ErrorF(
@@ -441,9 +477,14 @@ startup_trigger(int argc, char **argv, char **envp)
 
         kr = bootstrap_look_up(bootstrap_port, server_bootstrap_name, &mp);
         if (kr != KERN_SUCCESS) {
+#if MAC_OS_X_VERSION_MIN_REQUIRED >= 1050
             ErrorF("bootstrap_look_up(%s): %s\n", server_bootstrap_name,
                    bootstrap_strerror(
                        kr));
+#else
+            ErrorF("bootstrap_look_up(%s): %ul\n", server_bootstrap_name,
+                   (unsigned long)kr);
+#endif
             exit(EXIT_FAILURE);
         }
 
@@ -523,8 +564,24 @@ setup_console_redirect(const char *bundle_id)
 
     asl_set_filter(aslc, ASL_FILTER_MASK_UPTO(ASL_LEVEL_WARNING));
 
-    asl_log_descriptor(aslc, NULL, ASL_LEVEL_INFO, STDOUT_FILENO, ASL_LOG_DESCRIPTOR_WRITE);
-    asl_log_descriptor(aslc, NULL, ASL_LEVEL_NOTICE, STDERR_FILENO, ASL_LOG_DESCRIPTOR_WRITE);
+#if MAC_OS_X_VERSION_MAX_ALLOWED >= 1080
+# if MAC_OS_X_VERSION_MIN_REQUIRED < 1080
+    if (asl_log_descriptor)
+# endif
+    {
+        asl_log_descriptor(aslc, NULL, ASL_LEVEL_INFO, STDOUT_FILENO, ASL_LOG_DESCRIPTOR_WRITE);
+        asl_log_descriptor(aslc, NULL, ASL_LEVEL_NOTICE, STDERR_FILENO, ASL_LOG_DESCRIPTOR_WRITE);
+    }
+# if MAC_OS_X_VERSION_MIN_REQUIRED < 1080
+    else {
+        xq_asl_capture_fd(aslc, NULL, ASL_LEVEL_INFO, STDOUT_FILENO);
+        xq_asl_capture_fd(aslc, NULL, ASL_LEVEL_NOTICE, STDERR_FILENO);
+    }
+# endif
+#else
+    xq_asl_capture_fd(aslc, NULL, ASL_LEVEL_INFO, STDOUT_FILENO);
+    xq_asl_capture_fd(aslc, NULL, ASL_LEVEL_NOTICE, STDERR_FILENO);
+#endif
 }
 
 static void
@@ -630,20 +687,12 @@ main(int argc, char **argv, char **envp)
     mach_port_t mp;
     kern_return_t kr;
 
-    /* Ignore SIGPIPE */
-    signal(SIGPIPE, SIG_IGN);
-
     /* Setup our environment for our children */
     setup_env();
 
     /* The server must not run the PanoramiX operations. */
     noPanoramiXExtension = TRUE;
 
-#ifdef COMPOSITE
-    /* https://gitlab.freedesktop.org/xorg/xserver/-/issues/1409 */
-    noCompositeExtension = TRUE;
-#endif
-
     /* Setup the initial crasherporter info */
     strlcpy(__crashreporter_info_buff__, __crashreporter_info__base,
             sizeof(__crashreporter_info_buff__));
